{
FileEasy
--------

Ce petit compo tout simple permet la lecture et l'ecriture de fichier
texte tres facilement.

Il s'agit en fait d'un Tmemo surcharg.

Le contenu du fichier lu sera disponible dans le Memo.
Le contenu du fichier a ecrire doit etre stoquer dans le Memo.


Propriete :
-----------
  Path : chemin d'acces du fichier a lire ou a ecrire


Methode :
---------

          Read : Lecture du fichier texte et ajout du contenu au Memo
          ReadAndClearMemo : idem READ sauf que le Memo est vid avant
          WriteTXT : Eciture du contenu du Memo dans le fichier par crasement de l'ancien contenu
          AppendTXT : Ecriture du cintenu du Memo a la suite du fichier texte
          LigneX : retourne le conetenu de la ligne du Memo passe en parametre


Auteur :  FireJocker - www.firejocker.com
--------

Vous pouvez faire ce que vous voulez de ce compo,
de toute maniere il est sans pretention mais bien pratique a mon avis.

}
unit FileEasy;

interface

uses
  SysUtils, Classes, Controls, StdCtrls;

type
  TFileEasy = class(TMemo)

  private

          FPath : string;
          Ferror : Boolean;
          procedure SetPath(Path : string);

          procedure Ecrire(TypeEcriture : String);

  public

          Constructor Create(AOwner:TComponent); override;

          procedure Read;
          procedure ReadAndClearMemo;
          procedure Write;
          procedure Append;
          function LigneX(X : integer) : String;



  published

            property Path : string read FPath write SetPath;
            property Error : Boolean read Ferror;


end;


procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('JbComp', [TFileEasy]);
end;


Constructor TFileEasy.Create(AOwner:TComponent);
begin

      InHerited Create(AOwner);
      FPath := '';
      Ferror := True;

end;

procedure TFileEasy.SetPath(Path : string);
begin
      FPath := path;
end;


// Ecris le contenu du memo dans le fichier
procedure TFileEasy.Write;
begin
      ecrire('REWRITE');
end;

// rajoute le contenu du memo au fichier txt
procedure TFileEasy.Append;
begin
      ecrire('APPEND');
end;

// vide le memo et lis le fichier txt
procedure TFileEasy.ReadAndClearMemo;
begin
      Clear;  // vide le Memo
      Read;   // Lis le fichier Txt
end;

//lis le contenu du fichier et le stoque dans le memo
procedure TFileEasy.Read;
var
    F : TextFile;
    ligne : string;
begin

      AssignFile(F,FPath);
      {$I-}
      Reset(F);
      {$I+}
      if IoResult=0 then
      begin
            repeat
                  Readln(F,ligne);
                  Lines.Add(ligne);
            until Eof(F);
            CloseFile(F);
            Ferror := False;
      end
      else
        Ferror := true;
end;


// Retourne la ligne X ou '' si erreur
function TFileEasy.LigneX(X : integer) : String;
begin
      X := X - 1;

      if ( (X >= 0) And (X < Lines.Count) ) then
        LigneX := Lines[X]
      else
        LigneX := '';

end;



// *************************************************************************************************//
procedure TFileEasy.Ecrire(TypeEcriture : String);
var
    F : TextFile;
    i : integer;
begin

      if FPath <> '' then // Path existant
      begin
            AssignFile(F,Fpath);
            {$I-}
            if TypeEcriture = 'REWRITE' then
              Rewrite(F)
            else
              System.Append(F);
            {$I+}

            if IoResult=0 then
            begin
                  for i :=0 to Lines.Count - 1 do Writeln(F,Lines[i]);
                  CloseFile(F);
                  Ferror := false;
            end
            else
              Ferror := true;
      end;

end;





end.
